import { ChangeRequestCreateParams } from './internal/request';
export declare class ScrapboxWebsocketHandler {
    private readonly options;
    private socket;
    private room;
    private sid;
    private readonly request$;
    private readonly response$;
    constructor(options: {
        token?: string;
        autoOpen?: boolean;
        autoReconnect?: boolean;
    });
    commit({ projectId, userId, pageId, parentId, changes, }: {
        projectId: string;
        userId: string;
        pageId: string;
        parentId: string;
        changes: ChangeRequestCreateParams[];
    }): Promise<{
        sid: string;
    }>;
    join({ projectId, pageId }: {
        projectId: string;
        pageId: string;
    }): Promise<void>;
    private send;
    private getActiveSocket;
    private openNewSocket;
}
