import { Observable } from 'rxjs';
import type NodeWebSocket from 'ws';
export declare const defaultSerializer: (data: any) => string;
export declare const defaultDeserializer: (message: MessageEvent | NodeWebSocket.MessageEvent) => any;
export interface MessageDeserializer<T = MessageEvent | NodeWebSocket.MessageEvent, U = any> {
    (event: T): U;
}
export interface MessageSerializer<T = any, U = any> {
    (event: T): U;
}
export declare class IsomorphicWebSocket<ParsedMessage = any> {
    readonly environment: string;
    readonly websocket: WebSocket | NodeWebSocket;
    private readonly open$;
    private readonly error$;
    private readonly close$;
    private readonly message$;
    private readonly send$;
    get readyState(): number;
    constructor({ url, protocols, options, serializer, deserializer, }: {
        url: string;
        protocols?: string | string[];
        options?: NodeWebSocket.ClientOptions;
        serializer?: MessageSerializer;
        deserializer?: MessageDeserializer;
    });
    get open(): Observable<Event | NodeWebSocket.OpenEvent>;
    get error(): Observable<Event | NodeWebSocket.ErrorEvent>;
    get close(): Observable<CloseEvent | NodeWebSocket.CloseEvent>;
    get message(): Observable<ParsedMessage>;
    send(message: string): void;
}
